;by Eukalyptus
;AutoIt v3.3.9.21 or higher needed!

#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>


_GDIPlus_Startup()
Global Const $STM_SETIMAGE = 0x0172
Global $iW = 600, $iH = 230
Global $hGui = GUICreate("Loading", $iW, $iH, -1, -1, $WS_POPUP, $WS_EX_TOPMOST)
Global $cPic = GUICtrlCreatePic("", 0, 0, $iW, $iH)
GUICtrlSetState(-1, $GUI_DISABLE)
GUISetState()

Global $hHBmp_BG, $hB, $iPerc = 0, $iSleep = 10, $fPower = 0.25

GUIRegisterMsg($WM_TIMER, "PlayAnim")
DllCall("user32.dll", "int", "SetTimer", "hwnd", $hGui, "int", 0, "int", $iSleep, "int", 0)

Do
    Switch GUIGetMsg()
        Case $GUI_EVENT_CLOSE
            GUIRegisterMsg($WM_TIMER, "")
            _WinAPI_DeleteObject($hHBmp_BG)
            _GDIPlus_Shutdown()
            GUIDelete()
            Exit
    EndSwitch
Until False

Func PlayAnim()
    $hHBmp_BG = _GDIPlus_CogWheels($iPerc, $iW, $iH)
    $hB = GUICtrlSendMsg($cPic, $STM_SETIMAGE, $IMAGE_BITMAP, $hHBmp_BG)
    If $hB Then _WinAPI_DeleteObject($hB)
    _WinAPI_DeleteObject($hHBmp_BG)
    $iPerc += $fPower
    If ($iPerc > 110) Then
        $iPerc = 0
        $fPower = Random(0.03, 1)
    EndIf
EndFunc   ;==>PlayAnim


Func _GDIPlus_CogWheels($fProgress, $iW, $iH, $fSize = 260, $iColor = 0xFF454565)
    Local $hBmp = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
    Local $hGfx = _GDIPlus_ImageGetGraphicsContext($hBmp)
    _GDIPlus_GraphicsSetSmoothingMode($hGfx, 2)
    _GDIPlus_GraphicsClear($hGfx, 0xFF141414)

    Local Const $cPI = ATan(1) * 4
    Local Const $c2PI = $cPI * 2

    $fProgress = $fProgress < 0 ? 0 : ($fProgress > 100 ? 100 : $fProgress)
    $fSize /= 2.4
    Local $fCX = $iW * 0.55
    Local $fCY = $iH * 0.5 + $fSize * 0.3
    Local $fTooth = $fSize * 0.07

    Local Static $tCog1, $tCog2, $tCog3, $tCog, $fSizeStore
    If $fSize <> $fSizeStore Then
        $fSizeStore = $fSize
        $tCog = 0
        $tCog1 = 0
        $tCog2 = 0
        $tCog3 = 0
    EndIf

    Local $fA
    If Not IsDllStruct($tCog1) Then
        $tCog1 = DllStructCreate("int X; int Y; float Angle; float Rad; int Cnt; float Pnt[" & 72 & "];")
        $tCog1.Cnt = 36
        $tCog1.X = $fCX - $fSize * 0.53
        $tCog1.Y = $fCY - $fSize * 0.14
        $tCog1.Rad = $fSize * 0.4

        For $i = 0 To $tCog1.Cnt - 1
            $fA = $c2PI * $i / $tCog1.Cnt + $cPI
            $tCog1.Pnt(($i * 2 + 1)) = Sin($fA) * ($tCog1.Rad - $fTooth * Mod($i, 2))
            $tCog1.Pnt(($i * 2 + 2)) = Cos($fA) * ($tCog1.Rad - $fTooth * Mod($i, 2))
        Next
    EndIf


    If Not IsDllStruct($tCog2) Then
        $tCog2 = DllStructCreate("int X; int Y; float Angle; float Rad; int Cnt; float Pnt[" & 40 & "];")
        $tCog2.Cnt = 20
        $tCog2.X = $fCX - $fSize * 0.05
        $tCog2.Y = $fCY - $fSize * 0.43
        $tCog2.Rad = $fSize * 0.2

        For $i = 0 To $tCog2.Cnt - 1
            $fA = $c2PI * $i / $tCog2.Cnt + $cPI
            $tCog2.Pnt(($i * 2 + 1)) = Sin($fA) * ($tCog2.Rad - $fTooth * Mod($i, 2))
            $tCog2.Pnt(($i * 2 + 2)) = Cos($fA) * ($tCog2.Rad - $fTooth * Mod($i, 2))
        Next
    EndIf


    If Not IsDllStruct($tCog3) Then
        $tCog3 = DllStructCreate("int X; int Y; float Angle; float Rad; int Cnt; float Pnt[" & 56 & "];")
        $tCog3.Cnt = 28
        $tCog3.Rad = $fSize * 0.3
        $tCog3.X = $fCX + $fSize * 0.37
        $tCog3.Y = $fCY - $fSize * 0.24
        $tCog3.Angle = 10

        For $i = 0 To $tCog3.Cnt - 1
            $fA = $c2PI * $i / $tCog3.Cnt + $cPI
            $tCog3.Pnt(($i * 2 + 1)) = Sin($fA) * ($tCog3.Rad - $fTooth * Mod($i, 2))
            $tCog3.Pnt(($i * 2 + 2)) = Cos($fA) * ($tCog3.Rad - $fTooth * Mod($i, 2))
        Next
    EndIf


    If Not IsDllStruct($tCog) Then
        $tCog = DllStructCreate("float Pos; int X; int Y; int W; int H; int Cnt; float Pnt[" & 78 & "];")
        $tCog.Cnt = 39
        $tCog.W = $fSize * 2.4
        $tCog.H = $fSize * 0.1
        $tCog.X = $fCX - $fSize * 0.53 - $tCog.W
        $tCog.Y = $fCY + $fSize * 0.295

        For $i = 0 To $tCog.Cnt - 1
            $tCog.Pnt(($i * 2 + 1)) = $tCog.W * $i / $tCog.Cnt
            $tCog.Pnt(($i * 2 + 2)) = -$fTooth * Mod($i, 2)
        Next
    EndIf


    Local Static $fP = 0
    $fP += ($fProgress - $fP) / 8

    $tCog.Pos = $tCog.W * $fP / 100
    $tCog1.Angle = $tCog.Pos / ($tCog.W * $tCog1.Cnt / $tCog.Cnt) * 360 - 9
    $tCog2.Angle = $tCog1.Angle * $tCog1.Cnt / $tCog2.Cnt + 4
    $tCog3.Angle = $tCog1.Angle * $tCog1.Cnt / $tCog3.Cnt - 3


    Local $hPath = _GDIPlus_PathCreate()
    Local $hMatrix = _GDIPlus_MatrixCreate()

    DllCall($__g_hGDIPDll, "int", "GdipAddPathCurve2", "handle", $hPath, "struct*", DllStructGetPtr($tCog, "Pnt"), "int", $tCog.Cnt, "float", 0.5)
    _GDIPlus_MatrixTranslate($hMatrix, ($tCog.X + $tCog.Pos), $tCog.Y)
    _GDIPlus_PathAddLine($hPath, $tCog.Pnt((($tCog.Cnt - 1) * 2 + 1)), $tCog.Pnt(2), $tCog.Pnt((($tCog.Cnt - 1) * 2 + 1)), $tCog.Pnt(2) + $tCog.H)
    _GDIPlus_PathAddLine($hPath, $tCog.Pnt((($tCog.Cnt - 1) * 2 + 1)), $tCog.Pnt(2) + $tCog.H, $tCog.Pnt, $tCog.Pnt(2) + $tCog.H)
    _GDIPlus_PathCloseFigure($hPath)
    _GDIPlus_PathTransform($hPath, $hMatrix)

    _GDIPlus_MatrixSetElements($hMatrix)
    _GDIPlus_MatrixTranslate($hMatrix, -$tCog1.X, -$tCog1.Y, True)
    _GDIPlus_MatrixRotate($hMatrix, $tCog1.Angle, True)
    _GDIPlus_PathTransform($hPath, $hMatrix)
    DllCall($__g_hGDIPDll, "int", "GdipAddPathClosedCurve2", "handle", $hPath, "struct*", DllStructGetPtr($tCog1, "Pnt"), "int", $tCog1.Cnt, "float", 0.5)
    _GDIPlus_PathAddEllipse($hPath, -$tCog1.Rad * 0.6, -$tCog1.Rad * 0.6, $tCog1.Rad * 1.2, $tCog1.Rad * 1.2)
    _GDIPlus_MatrixInvert($hMatrix)
    _GDIPlus_PathTransform($hPath, $hMatrix)

    _GDIPlus_MatrixSetElements($hMatrix)
    _GDIPlus_MatrixTranslate($hMatrix, -$tCog2.X, -$tCog2.Y, True)
    _GDIPlus_MatrixRotate($hMatrix, -$tCog2.Angle, True)
    _GDIPlus_PathTransform($hPath, $hMatrix)
    DllCall($__g_hGDIPDll, "int", "GdipAddPathClosedCurve2", "handle", $hPath, "struct*", DllStructGetPtr($tCog2, "Pnt"), "int", $tCog2.Cnt, "float", 0.6)
    _GDIPlus_PathAddEllipse($hPath, -$tCog2.Rad * 0.4, -$tCog2.Rad * 0.4, $tCog2.Rad * 0.8, $tCog2.Rad * 0.8)
    _GDIPlus_MatrixInvert($hMatrix)
    _GDIPlus_PathTransform($hPath, $hMatrix)

    _GDIPlus_MatrixSetElements($hMatrix)
    _GDIPlus_MatrixTranslate($hMatrix, -$tCog3.X, -$tCog3.Y, True)
    _GDIPlus_MatrixRotate($hMatrix, $tCog3.Angle, True)
    _GDIPlus_PathTransform($hPath, $hMatrix)
    DllCall($__g_hGDIPDll, "int", "GdipAddPathClosedCurve2", "handle", $hPath, "struct*", DllStructGetPtr($tCog3, "Pnt"), "int", $tCog3.Cnt, "float", 0.5)
    _GDIPlus_PathAddEllipse($hPath, -$tCog3.Rad * 0.5, -$tCog3.Rad * 0.5, $tCog3.Rad, $tCog3.Rad)
    _GDIPlus_MatrixInvert($hMatrix)
    _GDIPlus_PathTransform($hPath, $hMatrix)
    _GDIPlus_MatrixDispose($hMatrix)


    Local $hPath_Txt = _GDIPlus_PathCreate()
    Local $hFamily = _GDIPlus_FontFamilyCreate("Impact")
    Local $tLayout = _GDIPlus_RectFCreate()
    _GDIPlus_PathAddString($hPath_Txt, "%", $tLayout, $hFamily, 0, $fSize * 0.4, 0)
    _GDIPlus_FontFamilyDispose($hFamily)

    Local $aBounds = _GDIPlus_PathGetWorldBounds($hPath_Txt)
    _GDIPlus_PathReset($hPath_Txt)
    $tLayout.X = $fCX + $fSize * 0.1
    $tLayout.Y = $fCY - $fSize * 0.82 - $aBounds[3]
    _GDIPlus_PathAddString($hPath_Txt, "%", $tLayout, $hFamily, 0, $fSize * 0.4, 0)
    Local $sPer = String(Int($fProgress))
    For $i = 1 To 3
        $tLayout.X -= $aBounds[2] * 0.9
        _GDIPlus_PathAddString($hPath_Txt, StringRight($sPer, 1), $tLayout, $hFamily, 0, $fSize * 0.4, 0)
        $sPer = StringTrimRight($sPer, 1)
    Next

    _GDIPlus_PathAddPath($hPath, $hPath_Txt)
    _GDIPlus_PathDispose($hPath_Txt)


    Local $hBrush = _GDIPlus_BrushCreateSolid($iColor)
    _GDIPlus_GraphicsFillPath($hGfx, $hPath, $hBrush)
    _GDIPlus_BrushDispose($hBrush)

    Local $tRect = DllStructCreate("float X; float Y; float W; float H;")
    $tRect.X = $fCX - $fSize
    $tRect.Y = $fCY - $fSize * 0.5
    $tRect.W = $fSize * 0.3
    $tRect.H = $fSize * 0.15

    Local Static $fRectOff = Random(-100, 100)
    $fRectOff += 0.6
    $tRect.X += $fRectOff

    $hBrush = _GDIPlus_LineBrushCreateFromRectWithAngle($tRect, 0x44FFFFFF, 0, 72, True, 3)
    _GDIPlus_LineBrushSetSigmaBlend($hBrush, 1)

    _GDIPlus_GraphicsFillPath($hGfx, $hPath, $hBrush)

    _GDIPlus_LineBrushSetColors($hBrush, 0, 0xAAFFFFFF)
    Local $hPenB = _GDIPlus_PenCreate2($hBrush, 2)
    _GDIPlus_BrushDispose($hBrush)

    _GDIPlus_GraphicsDrawPath($hGfx, $hPath, $hPenB)
    _GDIPlus_PenDispose($hPenB)

    _GDIPlus_PathDispose($hPath)


    Local $hHBITMAP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBmp)
    _GDIPlus_GraphicsDispose($hGfx)
    _GDIPlus_BitmapDispose($hBmp)
    Return $hHBITMAP
EndFunc   ;==>_GDIPlus_CogWheels